# controller.py
#
# The Controller class represents a robot program choosing
# actions based on sensory and odometric data...



import math
import random
# this next line is really just for the angle-handling functions
# which should be in a "mathHelp" file of global functions
# but this isn't really unsafe...
import mcl


class Controller:
    
    def __init__(self):
        """ the constructor takes an optional programNumber, so
            that this class essentially becomes a container for
            lots of different programs
            
            I suppose they could simply be stored in different
            versions of this file, too.
        """
        
        # starting program state and velocities
        
        self.show = True  # do we want to print state changes?    
        self.state = 'straight'  # initial state       
        self.desiredthr = 0.0  # not needed yet
        
        self.velocities = \
                { 'turningL':   (0.0,40.0),  # keep in one place
                  'turningR':   (0.0,-40.0),
                  'straight':   (50.0,0.0), 
                  'stop':       (0.0,0.0)   }
                                   
                                   
    def getVels(self, pose, collisions, sensors):
        """ returns the velocities the controller decides on 
            state-machine-based control
        """
        thr = pose[2]  # simpler to type and read
                
        # set appropriate state
        if len(collisions) > 0:
            # get a new heading on the other side of the robot
            self.desiredthr = thr + math.radians(random.uniform(90,270))
            # which way to go?
            bestdiff = mcl.computeSmallestSignedAngleDifference(thr,self.desiredthr)
            
            if bestdiff > 0:  self.state = 'turningL'
            else:             self.state = 'turningR'
            
            if (self.show): print 'Changing to state', self.state
            
        # check for our current state
        if self.state == 'turningL':
            # are we there yet?
            if self.thrAreWeThereYet(thr,'>',self.desiredthr): # we are!
                if (self.show): print 'Changing to state', self.state
                self.state = 'straight'
                
        # ditto
        if self.state == 'turningR':
            # are we there yet?
            if self.thrAreWeThereYet(thr,'<',self.desiredthr): # we are!
                if (self.show): print 'Changing to state', self.state
                self.state = 'straight'
        
        # we have our state (it may not have changed)
        # now we set the velocities
        return self.velocities[self.state]
        
        
    def thrAreWeThereYet(self,thrcur,direction,thrdes):
        """ angles are a pain! """
        # first, get within a window of our desired angle
        # note that this will only work for turns up to 360-window degrees
        # but we really shouldn't be turning more than 180
        # or the robot should have gone the other way!
        
        windowDegrees = math.radians(10)
        diff = mcl.computeSmallestSignedAngleDifference(thrcur,thrdes)
        
        if direction == '>': # we want thrcur bigger and thus diff < 0
            return diff < 0.0
            
        if direction == '<': # we want thrcur smaller and thus diff > 0
            return diff > 0.0
            
        print 'direction of', direction, 'in areWeThereYet not understood'
        return True






                                   
                                   
                                   
